> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/types/stream.md).

# stream

## Stream Methods

<details>

<summary><code>toBXList(delimiter=[string])</code></summary>

Collect a Java stream into a BoxLang delimited list.

Each item in the stream will cast to a string and then be joined with the delimiter.

Arguments:

| Argument    | Type     | Required | Default |
| ----------- | -------- | -------- | ------- |
| `delimiter` | `string` | `false`  | `,`     |

</details>

<details>

<summary><code>toBXArray()</code></summary>

Collect a Java stream into a BoxLang Array

</details>

<details>

<summary><code>toBXQuery(query=[query])</code></summary>

Collect a Java stream into a BoxLang Query.

Provide a template query to match the columns and types of the stream. Once the stream collects, it will return a Query object that can be used in BoxLang.

,

### ,Usage,

,

,

```
,
// Create a query template
templateQuery = queryNew( "id,name,age" );
// Create a stream from an array of structs
stream = [ {id:1, name:"John", age:30}, {id:2, name:"Jane", age:25} ].toStream();
// Convert the stream to a query
result = stream.toBXQuery( templateQuery );
,
```

Arguments:

| Argument | Type    | Required | Default |
| -------- | ------- | -------- | ------- |
| `query`  | `query` | `true`   | `null`  |

</details>

<details>

<summary><code>toBXStruct(type=[string])</code></summary>

Collect a Java stream into a BoxLang Struct.

Must be a stream of Map.Entry instances.

Arguments:

| Argument | Type     | Required | Default   |
| -------- | -------- | -------- | --------- |
| `type`   | `string` | `false`  | `default` |

</details>

## Examples


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/types/stream.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
